Summary:	ggrelay - Gadu-Gadu instant messenger transparent proxy with DCC support
Summary(pl):	ggrelay - przezroczyste proxy dla komunikatora Gadu-Gadu z obsug DCC
Name:		ggrelay
Version:	1.4
Release:	1
License:	GPL
Group:		Networking/Utilities
Source0:	%{name}-%{version}.tar.gz
PreReq:		/etc/rc.d/init.d
Requires(post,preun):	/sbin/chkconfig
Requires:	/sbin/ip
BuildRoot:	%{_tmppath}/%{name}-%{version}-root-%(id -u -n)

%description
This small application is a simple GG relaying agent. This means, that
if you are a network administrator and applying masquerade on your
server, it's likely, that your customers would like to establish
direct connections over the masquerade using GG. This program is
intended to be the solution.

%description -l pl
Ta maa aplikacja jest prostym agentem przekazujcym GG. Oznacza to,
e pozwala na uywanie transferw plikw pomidzy uytkownikami
Gadu-Gadu, ktrzy schowani s za NAT-em (aka maskarad).

%prep
%setup -q

%build
%configure \
	--prefix="$RPM_BUILD_ROOT%{_prefix}"
%{__make}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT

%{__make} install
./install.sh --rpmbuild "$RPM_BUILD_ROOT"

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/chkconfig --add ggrelay
if [ -f /var/lock/subsys/ggrelay ]; then
	/etc/rc.d/init.d/ggrelay restart 1>&2
else
	echo
	echo "Installation completed."
	echo
	echo "1. Run \"/etc/rc.d/init.d/ggrelay start\" to start daemon."
	echo "2. Finally setup iptables to redirect connections:"
	echo "   \$ iptables -t nat -A PREROUTING -p tcp --dport 8074 -j REDIRECT"
	echo "   \$ iptables -I FORWARD -o <external iface> -d 217.17.41.0/24 -p tcp \\"
	echo "       --dport 443 -j REJECT"
	echo
fi

%preun
if [ "$1" = 0 ]; then
	if [ -f /var/lock/subsys/ggrelay ]; then
		/etc/rc.d/init.d/ggrelay stop >&2
	fi
	/sbin/chkconfig --del ggrelay
fi

%files
%defattr(644,root,root,755)
%doc README.en README.pl COPYING
%attr(755,root,root) %{_sbindir}/ggrelay
%config(noreplace) %verify(not size mtime md5) %attr(640,root,root) %{_sysconfdir}/sysconfig/ggrelay
%attr(754,root,root) /etc/rc.d/init.d/ggrelay

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* Tue Apr 27 2004 accek <accek@poczta.gazeta.pl>
Adjusted to match new rc-scripts

* Sat Feb 07 2004 accek <accek@poczta.gazeta.pl>
Adjusted for more general use

* Sat Feb 07 2004 PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

Revision 1.2  2004/02/07 01:20:34  qboosh
- some cleanups

Revision 1.1  2004/02/06 22:03:44  hunter
- initial pld spec.

* Fri Feb 06 2004 accek <accek@poczta.gazeta.pl>
Initial specfile.
