#!/bin/bash

test -f scripts/ggrelay || exit 1
test -f scripts/ggrelay.conf || exit 1
test -f autogen.sh  || exit 1

fail()
{
	echo "installation failed: $*"
	exit 1
}

RPMBUILDDIR=
[ "$1" == "--rpmbuild" ] && RPMBUILDDIR="$2"

if [ -z "$RPMBUILDDIR" ]; then
	echo "Building ..."
	test -f configure || ./autogen.sh || fail "autogen.sh failed"
	./configure --enable-debug || fail "configure failed"
	make || fail "make failed"
	make install || fail "make install failed"
fi

echo "Installing scripts ..."
install -d $RPMBUILDDIR/etc/rc.d/init.d
install scripts/ggrelay $RPMBUILDDIR/etc/rc.d/init.d/ || \
	fail "error copying to /etc/rc.d/init.d"
install -d $RPMBUILDDIR/etc/sysconfig
if [ -f "$RPMBUILDDIR/etc/sysconfig/ggrelay" ]; then
	echo "Your /etc/sysconfig/ggrelay has just been overwritten."
	echo "I'm sorry if your changes have been lost."
fi
install -m 640 scripts/ggrelay.conf $RPMBUILDDIR/etc/sysconfig/ggrelay || \
	fail "error copying to /etc/sysconfig"
[ -z "$RPMBUILDDIR" ] && /sbin/chkconfig --add ggrelay
echo "Installation complete. Don't forget to setup iptables properly."
